<template>
    <div class="bottom-margin-100">

        <p>An open ride lets you offer a ride within a specified window of days and times instead of an exact date and time.</p>

        <SuccessCreation
            v-bind:from="addressFrom.locality"
            v-bind:to="addressTo.locality"
            v-if="successCreate"
        />
        <div class="border-form" v-if="!successCreate">
            
            <div class="alert alert-danger" role="alert" v-if="displayMessage">
                <ul> 
                    <li v-for="item in message"> {{ item }} </li>
                </ul>
            </div>
            <div class="row bottom-pad-10">
                <div class="col-md-6 col-sm-12">
                    <div class="form-with-label">
                        <span class="ride-label">Start Window</span>
                        <div class="frm-ride datepickicon chunkypuff-openride">
                            <datepicker v-model="dateFrom" @selected="restrictDates" id="dateFrom" placeholder="From Date " :disabled-dates="state.disabledDates"></datepicker>
                        </div>
                    </div>
                </div>
                <div class="col-md-6 col-sm-12">
                    <div class="form-with-label">
                        <span class="ride-label">End Window</span>
                        <div class="frm-ride datepickicon chunkypuff-openride">
                            <datepicker id="dateFrom" v-model="dateTo" placeholder="Up To Date" :disabled-dates="secondState.disabledDates"></datepicker>
                        </div>
                    </div> 
                </div>
            </div>
            <div class="form-with-label bottom-pad-10">
                <span class="ride-label">Drive Hour Timeslots</span>
                <div class="frm-ride chunkypuff-openride">
                    <multiselect v-model="hoursAvailable" :multiple="true" deselect-label="Can't remove this value" track-by="time" label="time"
                                 placeholder="Select one" :options="options" :searchable="true" :allow-empty="false">
                        <template slot="singleLabel" slot-scope="{ option }"><strong>{{ option.time }}</strong></template>
                    </multiselect>
                </div>
            </div>


            <div class="row bottom-pad-10">
                <div class="col-md-6 col-sm-12">
                    <div class="form-with-label">
                        <span class="ride-label">Seats</span>
                        <div class="frm-ride chunkypuff-openride">
                            <integer-plusminus class="clearvuestyle" 
                                                :min="1"
                                               :max="5"
                                               :step="1"
                                               :vertical="false"
                                               v-model="seats">
                                {{ seats }}

                                <template slot="decrement"><span class="negsignpad">-</span></template>

                                <template slot="increment">+</template>
                            </integer-plusminus>
                        </div>
                    </div>
                </div>
                <div class="col-md-6 col-sm-12">
                    <div class="form-with-label">
                        <span class="ride-label">Seat Price</span>
                        <div class="frm-ride chunkypuff-openride">
                            <integer-plusminus class="clearvuestyle" 
                                                :min="0"
                                               :max="ipm_max"
                                               :step="1"
                                               :vertical="false"
                                               v-model="driverPrice">
                                $ {{ driverPrice }}

                                <template slot="decrement"><span class="negsignpad">-</span></template>

                                <template slot="increment">+</template>
                            </integer-plusminus>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row bottom-pad-10">
                <div class="col-md-6 col-sm-12">
                    <div class="form-with-label">
                        <span class="ride-label">Luggage Amount</span>
                        <div class="frm-ride chunkypuff-openride">
                            <integer-plusminus class="clearvuestyle" :min="0"
                                               :max="5"
                                               :step="1"
                                               :vertical="false"
                                               v-model="luggage_amount">
                                {{ luggage_amount }}

                                <template slot="decrement"><span class="negsignpad">-</span></template>

                                <template slot="increment">+</template>
                            </integer-plusminus>
                        </div>
                    </div>
                </div>
                <div class="col-md-6 col-sm-12">
                    <div class="form-with-label">
                        <span class="ride-label">Luggage Size</span>
                        <div class="frm-ride">
                            <select v-model="luggage_size" class="form-control chunkypuff">
                                <option value="Small">Small</option>
                                <option value="Medium">Medium</option>
                                <option value="Large">Large</option>
                            </select>
                        </div>
                    </div>
                </div>
            </div>


            <div class="form-with-label">
                <span class="ride-label">Ride Purpose</span>
                <div class="frm-ride">
                    <select v-model="trip_purpose_id" class="form-control chunkypuff">
                        <option value="item.id" 
                        v-for="item in purpose"
                        v-bind:value="item.id"
                        
                        >{{item.type}}</option>
                    </select>
                </div>
            </div>

            <div class="form-with-label">
                <span class="ride-label">Description</span>
                <div class="frm-ride">
                    <textarea v-model="description" class="pufftext" placeholder="Add ride information here"></textarea>
                </div>
            </div>

            
            <button class="btn btn-primary pull-right" v-on:click="postData">Create Ride</button>
            <button class="btn btn-light pull-right margin-right-15" v-on:click="returnBack">&larr; Back</button>
            
        </div>
       
    </div>


</template>

<script>

    import Datepicker from 'vuejs-datepicker';
    import Multiselect from 'vue-multiselect'
    import {IntegerPlusminus} from 'vue-integer-plusminus'
    import axios from 'axios';
    import SuccessCreation from './SuccessCreation'

    export default {
        props:['price', 'addressFrom', 'addressTo', 'duration'],
        name: "RideInformation",
        components: {
            Datepicker, Multiselect, IntegerPlusminus, axios, SuccessCreation
        },
        data(){
            return{
                seats:1,
                dateFrom:'',
                dateTo:'',
                trip_purpose_id:1,
                hoursAvailable:[],
                options:[
                    {time: '1:00 AM'}, {time: '2:00 AM'}, {time: '3:00 AM'}, {time: '4:00 AM'},
                    {time: '5:00 AM'}, {time: '6:00 AM'}, {time: '7:00 AM'}, {time: '8:00 AM'},
                    {time: '9:00 AM'}, {time: '10:00 AM'}, {time: '11:00 AM'}, {time: '12:00 AM'},
                    {time: '1:00 PM'}, {time: '2:00 PM'}, {time: '3:00 PM'}, {time: '4:00 PM'},
                    {time: '5:00 PM'}, {time: '6:00 PM'}, {time: '7:00 PM'}, {time: '8:00 PM'},
                    {time: '9:00 PM'}, {time: '10:00 PM'}, {time: '11:00 PM'}, {time: '12:00 PM'}
                ],
                luggage_size: 'Small',
                luggage_amount:1,
                description:'',
                start:0,
                driverPrice:this.price,
                ipm_max: this.price + (this.price*1.50),
                state:{disabledDates: {
                        to: new Date(),
                    }
                },
                secondState:{
                    disabledDates:{
                        to: new Date(),
                    },
                },
                purpose:'',
                message:[],
                displayMessage:false,
                successCreate:false,
            }
        },
        mounted(){
            this.getPurposes();
            
        },
        methods: {
            returnBack:function () {
                this.$emit('update:isRoute', true);
            },
            restrictDates:function (){
                console.log('entering');
                if(jQuery('#dateFrom').val() != ''){
                    this.secondState ={
                        disabledDates: {
                           to: new Date(this.dateFrom)
                        }
                    }
                }
            },
            getPurposes:function(){
                axios.get('/rides/fetchPurpose', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    }
                }).then(response => {
                    this.purpose = response.data;
                }).catch(e => {
                    this.errors.push(e)
                })
            },
            postData: function () {

                var validation = this.validation();
                if(validation == false){
                    window.scrollTo({top: 0, behavior: 'smooth'});
                    return false;
                }
                var location_from = this.addressFrom.locality + ", " + this.addressFrom.administrative_area_level_1 + ", " + this.addressFrom.country;
                var location_to = this.addressTo.locality + ", " + this.addressTo.administrative_area_level_1 + ", " + this.addressTo.country;
                var city_from = this.addressFrom.locality + ", " + this.addressFrom.administrative_area_level_1;
                var city_to = this.addressTo.locality + ", " + this.addressTo.administrative_area_level_1;
                axios.post('/rides/open-rides', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                        'location_from':location_from,
                        'location_to':location_to,
                        'city_from':city_from,
                        'city_to':city_to,
                        'description':this.description,
                        'luggage_size':this.luggage_size,
                        'luggage_amount':this.luggage_amount,
                        'open_date_from':this.dateFrom,
                        'open_date_to':this.dateTo,
                        'hours':this.hoursAvailable,
                        'duration':this.duration,
                        'trip_purpose_id':this.trip_purpose_id,
                        'seats':this.seats,
                        'price':this.driverPrice,
                    }
                }).then(response => {
                    this.successCreate = true;
                    window.scrollTo({top: 0, behavior: 'smooth'});
                }).catch(e => {
                    this.displayMessage = true;
                    this.message.push(e.response.data.message);
                    window.scrollTo({top: 0, behavior: 'smooth'});
                })
            },

            validation: function(){
                var val = true;
                if(this.dateFrom == ''){
                    val = false;
                    this.displayMessage = true;
                    this.message.push('Start date is empty');
                }
                if(this.dateTo == ''){
                    val = false;
                    this.displayMessage = true;
                    this.message.push('End date is empty');
                }
                if(this.hoursAvailable == ''){
                    val = false;
                    this.displayMessage = true;
                    this.message.push('Times available is empty');
                }

                return val;
            },
        }
    }

</script>
<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>

<!-- Change Vue Component Default Style on Increment/Decrement inputs -->
<style lang="scss">

.int-pm {
    &.clearvuestyle {

        width: 100px !important;
        min-width: 150px !important;
        width: 100% !important;

        .int-pm-value {
            background-color: none;
            color: black;
            font-size: 1.5em;
            padding: 5px 0px !important;
            border: none !important;
            line-height: 1;
            min-width: 150px !important;
        }
        .int-pm-btn {
            border: none !important;
            background: #ddd !important;
            color: white;
            border-radius: 50% !important;
            display: block !important;
            width: 45px !important;
            font-size: 2em !important;
            line-height: 0 !important;
            padding: 0 !important;
        }
        .int-pm-increment {
            padding: 0 !important;
        }
        .int-pm-decrement {
            padding: 0 !important;
        }
    }
}

.negsignpad {
    
    position: relative; 
    bottom: 3px;
}

#dateFrom{
    box-sizing: border-box;
    display: block;
    min-width: 90px;
    max-width: 150px;
    height: 38px;
    border: 1px solid #eee;
    border-radius: 5px;
    padding: 0 0 0 8px !important;
    margin-left: 50px !important;
    font-size: 15px;
    font-weight: 500;
}

.datepickicon:before
{
    content: "\f133";
    font-family: FontAwesome !important;
    position: absolute;
    font-size: 23px;
    margin-left: 10px;
    margin-top: 3px;
    color: #777;
}

</style>